# Generated by Django 3.2.19 on 2023-06-18 19:33

import django.core.validators
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("users", "0007_alter_ruleset_name"),
    ]

    operations = [
        migrations.CreateModel(
            name="Approval",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "metadata",
                    models.JSONField(
                        blank=True,
                        help_text="JSON metadata field, for use by external plugins",
                        null=True,
                        verbose_name="Plugin Metadata",
                    ),
                ),
                ("reference_int", models.BigIntegerField(default=0)),
                (
                    "creation_date",
                    models.DateTimeField(
                        auto_now_add=True, verbose_name="Creation date"
                    ),
                ),
                (
                    "modified_date",
                    models.DateTimeField(
                        auto_now=True, verbose_name="Last modified date"
                    ),
                ),
                (
                    "finalised",
                    models.BooleanField(default=False, verbose_name="Finalised"),
                ),
                (
                    "finalised_date",
                    models.DateTimeField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Finalisation date",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "description",
                    models.TextField(blank=True, verbose_name="Description"),
                ),
                (
                    "reference",
                    models.CharField(
                        blank=True, max_length=100, verbose_name="Reference"
                    ),
                ),
                ("data", models.JSONField(blank=True, null=True, verbose_name="Data")),
                (
                    "status",
                    models.PositiveIntegerField(
                        choices=[
                            (0, "New"),
                            (10, "Pending"),
                            (20, "Approved"),
                            (30, "Rejected"),
                            (40, "Cancelled"),
                            (50, "Expired"),
                        ],
                        default=0,
                        help_text="Approval status",
                        validators=[django.core.validators.MinValueValidator(0)],
                        verbose_name="Status",
                    ),
                ),
                ("object_id", models.PositiveIntegerField()),
                (
                    "content_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="contenttypes.contenttype",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="approvals_created",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Created by",
                    ),
                ),
                (
                    "finalised_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="approvals_finalised",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Finalised by",
                    ),
                ),
                (
                    "modified_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="approvals_modified",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Last modified by",
                    ),
                ),
                (
                    "owner",
                    models.ForeignKey(
                        blank=True,
                        help_text="User or group that owns this approval",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="approvals_owned",
                        to="users.owner",
                        verbose_name="Owner",
                    ),
                ),
                (
                    "responsible",
                    models.ForeignKey(
                        blank=True,
                        help_text="User or group responsible for this approval",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="approvals_responsible",
                        to="users.owner",
                        verbose_name="Responsible",
                    ),
                ),
            ],
            options={
                "verbose_name": "Approval",
                "verbose_name_plural": "Approvals",
            },
        ),
        migrations.CreateModel(
            name="ApprovalDecision",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "metadata",
                    models.JSONField(
                        blank=True,
                        help_text="JSON metadata field, for use by external plugins",
                        null=True,
                        verbose_name="Plugin Metadata",
                    ),
                ),
                ("date", models.DateTimeField(auto_now_add=True, verbose_name="Date")),
                ("decision", models.BooleanField(verbose_name="Decision")),
                ("comment", models.TextField(blank=True, verbose_name="Comment")),
                (
                    "approval",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="decisions",
                        to="inventree_approval.approval",
                        verbose_name="Approval",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="User",
                    ),
                ),
            ],
            options={
                "verbose_name": "Approval decision",
                "verbose_name_plural": "Approval decisions",
                "unique_together": {("approval", "user")},
            },
        ),
    ]
