"""Notification bodies for the inventree-approval app."""
from common.notifications import NotificationBody
from django.utils.translation import gettext_lazy as _

ApprovalStarted = NotificationBody(
    name=_("New approval for {verbose_name}"),
    slug="{app_label}.new_{model_name}_approval",
    message=_("An approval was started for a order that is assigned to you"),
    template="email/new_order_assigned.html",
)
"""Send when an approval for a order was started."""

ApprovalDecisionAdded = NotificationBody(
    name=_("New approval decision"),
    slug="{app_label}.new_{model_name}_approval_decision",
    message=_("An approval decision was added for a order that is assigned to you"),
    template="email/order_approval_decision_added.html",
)
"""Send when an approval decision for a order was added."""
